
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)

A #GOnce struct controls a one-time initialization function. Any
one-time initialization function must have its own unique #GOnce
struct.
-}

module GI.GLib.Structs.Once
    ( 

-- * Exported types
    Once(..)                                ,
    noOnce                                  ,


 -- * Properties
-- ** Retval
    onceReadRetval                          ,


-- ** Status
    onceReadStatus                          ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.GLib.Types
import GI.GLib.Callbacks

newtype Once = Once (ForeignPtr Once)
noOnce :: Maybe Once
noOnce = Nothing

onceReadStatus :: Once -> IO OnceStatus
onceReadStatus s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 0) :: IO CUInt
    let val' = (toEnum . fromIntegral) val
    return val'

onceReadRetval :: Once -> IO (Ptr ())
onceReadRetval s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 8) :: IO (Ptr ())
    return val


