
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)

An opaque structure representing a test suite.
-}

module GI.GLib.Structs.TestSuite
    ( 

-- * Exported types
    TestSuite(..)                           ,
    noTestSuite                             ,


 -- * Methods
-- ** testSuiteAdd
    testSuiteAdd                            ,


-- ** testSuiteAddSuite
    testSuiteAddSuite                       ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.GLib.Types
import GI.GLib.Callbacks

newtype TestSuite = TestSuite (ForeignPtr TestSuite)
noTestSuite :: Maybe TestSuite
noTestSuite = Nothing

-- method TestSuite::add
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "GLib" "TestSuite", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "test_case", argType = TInterface "GLib" "TestCase", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "GLib" "TestSuite", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "test_case", argType = TInterface "GLib" "TestCase", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "g_test_suite_add" g_test_suite_add :: 
    Ptr TestSuite ->                        -- _obj : TInterface "GLib" "TestSuite"
    Ptr TestCase ->                         -- test_case : TInterface "GLib" "TestCase"
    IO ()


testSuiteAdd ::
    (MonadIO m) =>
    TestSuite ->                            -- _obj
    TestCase ->                             -- test_case
    m ()
testSuiteAdd _obj test_case = liftIO $ do
    let _obj' = unsafeManagedPtrGetPtr _obj
    let test_case' = unsafeManagedPtrGetPtr test_case
    g_test_suite_add _obj' test_case'
    touchManagedPtr _obj
    touchManagedPtr test_case
    return ()

-- method TestSuite::add_suite
-- method type : OrdinaryMethod
-- Args : [Arg {argName = "_obj", argType = TInterface "GLib" "TestSuite", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "nestedsuite", argType = TInterface "GLib" "TestSuite", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- Lengths : []
-- hInArgs : [Arg {argName = "_obj", argType = TInterface "GLib" "TestSuite", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing},Arg {argName = "nestedsuite", argType = TInterface "GLib" "TestSuite", direction = DirectionIn, mayBeNull = False, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, transfer = TransferNothing}]
-- returnType : TBasicType TVoid
-- throws : False
-- Skip return : False

foreign import ccall "g_test_suite_add_suite" g_test_suite_add_suite :: 
    Ptr TestSuite ->                        -- _obj : TInterface "GLib" "TestSuite"
    Ptr TestSuite ->                        -- nestedsuite : TInterface "GLib" "TestSuite"
    IO ()


testSuiteAddSuite ::
    (MonadIO m) =>
    TestSuite ->                            -- _obj
    TestSuite ->                            -- nestedsuite
    m ()
testSuiteAddSuite _obj nestedsuite = liftIO $ do
    let _obj' = unsafeManagedPtrGetPtr _obj
    let nestedsuite' = unsafeManagedPtrGetPtr nestedsuite
    g_test_suite_add_suite _obj' nestedsuite'
    touchManagedPtr _obj
    touchManagedPtr nestedsuite
    return ()


